package xyz.tbvns.GeometryDash;

import org.apache.commons.io.FileUtils;

import javax.imageio.ImageIO;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import static java.lang.Math.round;

public class TextureExtractor {
    public static void extract(File plist, File textures, File output) throws IOException {
        String config = FileUtils.readFileToString(plist);
        BufferedImage image = ImageIO.read(textures);
        String[] readableConfig = config
                .replace(" ", "")
                .split("\n");

        String name = "";
        float x = 0, y = 0, w = 0, h = 0;
        boolean rotated = false, ready = false;
        for (int i = 0; i < readableConfig.length; i++) {
            String line = readableConfig[i];
            if (line.startsWith("<key>") && line.endsWith(".png</key>")) {
                name = line.replace("<key>", "").replace("</key>", "");
            }
            else if (line.equals("<key>textureRect</key>")) {
                String data = readableConfig[i+1];
                String[] readableData = data
                        .replace("<string>", "")
                        .replace("</string>", "")
                        .replace("}", "")
                        .replace("{", "")
                        .split(",");
                x = Float.parseFloat(readableData[0]);
                y = Float.parseFloat(readableData[1]);
                w = Float.parseFloat(readableData[2]);
                h = Float.parseFloat(readableData[3]);
            } else if (line.equals("<key>textureRotated</key>")) {
                if (readableConfig[i+1].equals("<true/>")) {
                    rotated = true;
                } else {
                    rotated = false;
                }
            }
            else if (line.equals("</dict>")) {
                ready = true;
            }
            if (ready && !name.isBlank() && !new File(output.getPath() + "/" + name).exists()) {
                BufferedImage crop;
                try {
                    if (!rotated) {
                        crop = image.getSubimage(round(x), round(y), round(w), round(h));
                    } else {
                        crop = rotate(image.getSubimage(round(x), round(y), round(h), round(w)));
                    }
                    ImageIO.write(crop, "png", new File(output.getPath() + "/" + name));
                } catch (Exception e) {}
                x=0; y=0; w=0; h=0; name = "";
            }
        }
    }

    public static BufferedImage rotate(BufferedImage src) {
        int width = src.getWidth();
        int height = src.getHeight();
        BufferedImage output = new BufferedImage(height, width, src.getType());

        Graphics2D g2d = (Graphics2D)output.getGraphics();
        g2d.translate(height/2., width/2.);
        g2d.rotate((Math.PI/2) * 3);
        g2d.translate(-width/2., -height/2.);
        g2d.drawImage(src, 0,0,width, height,null);

        return output;
    }
}
