package xyz.tbvns.Managers;

import com.badlogic.gdx.files.FileHandle;
import com.badlogic.gdx.graphics.GL20;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g3d.Material;
import com.badlogic.gdx.graphics.g3d.attributes.BlendingAttribute;
import com.badlogic.gdx.graphics.g3d.attributes.TextureAttribute;
import org.apache.commons.codec.Resources;
import xyz.tbvns.ConfigManager;

import java.io.File;
import java.util.HashMap;

public class TexturesManager {
    public static HashMap<Integer, File> idFileMap;
    public static HashMap<Integer, Material> idMaterialMap;
    public static HashMap<Integer, Texture> idTextureMap;
    static {
        try {
            idFileMap = ConfigManager.parsedTextureMap(ConfigManager.read(new String(Resources.getInputStream("IDList.yml").readAllBytes())));
            idFileMap.forEach((k, v) -> {
                if (!v.exists()) {
                    System.out.println(v.getPath());
                }
            });

            idMaterialMap = new HashMap<>();
            idTextureMap = new HashMap<>();
            idFileMap.forEach((k, v) -> {
                if (v.exists()) {
                    Texture texture = new Texture(
                            new FileHandle(
                                    TexturesManager.idFileMap.get(k)
                            )
                    );
                    Material material = new Material(TextureAttribute.createDiffuse(texture), new BlendingAttribute(GL20.GL_SRC_ALPHA, GL20.GL_ONE_MINUS_SRC_ALPHA));
                    idMaterialMap.put(k, material);
                    idTextureMap.put(k, texture);
                }
            });
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    public static void dispose() {
        idTextureMap.forEach((k, v) -> {
            v.dispose();
        });
        idTextureMap.clear();
    }
}
